/*
** ocd - ojnk cd player
** Copyright (C) 1999 Odin <odin@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
*/

#ifndef __OCD_H
#define __OCD_H

#define _GNU_SOURCE

#include <curses.h>
#undef __USE_XOPEN
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>

#include <ojnk.h>
#include <ocd_cddb.h>
#include <gen_window.h>

#define ME "ocd 0.1"
#define VERSION "0"
#define REVISION "1"

struct cdrom {
	int fd;
	disc_t disc;
	cddb_t cddb;
	u_short mode;
	u_char device[128];
	struct cdrom_volctrl vol;
};

#define ATTR_CURTRK (A_BOLD)
#define ATTR_CURSEL (COLOR_PAIR(12) | A_BOLD | A_REVERSE)

#define NORMAL 0
#define REP_T 1
#define REP_C 2
#define PLAYLIST 3
#define SHUFFLE 4

#define OPENED 0x02

#ifdef NCURSES_MOUSE_VERSION
#define COL_1 28
#define COL_2 42
#define COL_3 61
#define CY_NEXT 1
#define CY_PREV 2
#define CY_STOP 3
#define CY_PAUSE 4
#define CY_REW 5
#define CY_FF 6
#define CY_EJECT 1 
#define CY_CLOSE 2
#define CY_GOTO 3
#define CY_VOLR 4
#define CY_VOLL 5
#define CY_MUTE 6
#define CY_CDDB 1
#define CY_EDIT 2
#define CY_REP 3
#define CY_MODE 4
#define CY_QUIT 5
#endif

#define CDDB_STWIN_X 3
#define CDDB_STWIN_Y (max_y - 2)

#define DEFAULT_CDROM_DEV "/dev/cdrom"
#define OCDRC ".ocdrc"

#define INVALID_TRACK(x, y) (x < 1 || x > y)
#define MIN(x, y) (x < y ? x : y)
#define xfree(ptr) { free(ptr), ptr = NULL; }

#include <ocd_proto.h>
#ifndef __GLIBC__
int dprintf(int fd, const char *fmt, ...);
int vdprintf(int fd, const char *fmt, va_list ap);
#endif

#endif /* __OCD_H */
